var express = require('express');
var graphqlHTTP = require('express-graphql');
var { buildSchema } = require('graphql');

var schema = buildSchema(`
  type Query {
    salary: String
  }
`);

var root = {
  salary: () => {
		var mongoose = require('mongoose'),
		Schema = mongoose.Schema;
		var db = mongoose.connect('mongodb://localhost/local',  { useNewUrlParser: true });

		var Salaries = new Schema({
		  emp_no: String,
		  first_name: String,
		  last_name: String,
		  salary: String,
		  from_date: String,
		  to_date: String
		});

		var SalaryModel = mongoose.model('Salaries', Salaries);
		
		var query = SalaryModel.find({ emp_no: '10001'}, function(err, Salaries) {}).sort([['from_date', 'ascending']]);		
		
		return query.then(function (retsalaries) {
			console.log(retsalaries);
			return 'First salary for ' + retsalaries[0].first_name + " " + retsalaries[0].last_name + " = " + retsalaries[0].salary;
		});
			
	}
};

var app = express();
app.use('/graphql', graphqlHTTP({
  schema: schema,
  rootValue: root,
  graphiql: true,
}));
app.listen(4000);
console.log('Running a GraphQL API server at localhost:4000/graphql');
