<?php
require_once __DIR__ . './autoload.php';
require_once __DIR__ . './config.php';

use GraphQL\Type\Definition\ObjectType;
use GraphQL\Type\Definition\Type;
use GraphQL\Type\Schema;
use GraphQL\GraphQL;

try {

    $queryType = new ObjectType([
        'name' => 'Query',
			'fields' => [
				'LastSalary' => [
					'type' => Type::string(),
					'args' => [
						'emp_no' => ['type' => Type::string()],
					],
					'resolve' => function ($root, $args) {
						$query = "select s.salary, s.from_date, s.to_date, e.first_name, e.last_name
								from salaries s
								inner join employees e on s.emp_no = e.emp_no
								where s.emp_no = '" . $args['emp_no'] . "' 
								order by s.from_date desc limit 1";
						$result = mysql_query($query);
						while($rec = mysql_fetch_array($result)) { 
							$salary = $rec['salary'];
							$period = $rec['from_date'] . ' - ' . $rec['to_date'];
							$employee = $rec['first_name'] . ' ' . $rec['last_name'];
						}
						return $root['prefix'] . $salary . ' (' . $period . ') ' . $employee;
					}
				],
				'FirstSalary' => [
					'type' => Type::string(),
					'args' => [
						'emp_no' => ['type' => Type::string()],
					],
					'resolve' => function ($root, $args) {
						$query = "select s.salary, s.from_date, s.to_date, e.first_name, e.last_name
								from salaries s
								inner join employees e on s.emp_no = e.emp_no
								where s.emp_no = '" . $args['emp_no'] . "' 
								order by s.from_date asc limit 1";
						$result = mysql_query($query);
						while($rec = mysql_fetch_array($result)) { 
							$salary = $rec['salary'];
							$period = $rec['from_date'] . ' - ' . $rec['to_date'];
							$employee = $rec['first_name'] . ' ' . $rec['last_name'];
						}
						return $root['prefix'] . $salary . ' (' . $period . ') ' . $employee;
					}
				],
		],		
	]);

$mutationType = new ObjectType([
        'name' => 'Calc',
        'fields' => [
            'addee' => [
                'type' => Type::string(),
                'args' => [
                    'emp' => ['type' => Type::string()],
					'from' => ['type' => Type::string()],
					'to' => ['type' => Type::string()],
                    'salary' => ['type' => Type::int()],
                ],
                'resolve' => function ($root, $args) {
				$query = "insert into salaries (emp_no, salary, from_date, to_date) 
					values ('" . $args['emp'] . "'," . $args['salary'] . ",'" . 
					$args['from'] . "','" . $args['to'] . "')";
				$result = mysql_query($query);
					if ($result == 1)
						return "Added salary for " . $args['emp'];
					else
						return "Error adding salary";
			},
		],
	],
]);

    $schema = new Schema([
        'query' => $queryType,
        'mutation' => $mutationType,
    ]);

    $rawInput = file_get_contents('php://input');
    $input = json_decode($rawInput, true);
    $query = $input['query'];
    $variableValues = isset($input['variables']) ? $input['variables'] : null;

    $rootValue = ['prefix' => 'Salary: '];
    $result = GraphQL::executeQuery($schema, $query, $rootValue, null, $variableValues);
    $output = $result->toArray();
} catch (\Exception $e) {
    $output = [
        'error' => [
            'message' => $e->getMessage()
        ]
    ];
}
header('Content-Type: application/json; charset=UTF-8');
echo json_encode($output);
